def jparsedate(str)
  year = month = day = hour = min = sec = 0 
  str.scan(/(|)?(\d+)(ǯ||||ʬ|)/){
    case $3
    when "ǯ"; year  = $2.to_i
    when ""; month = $2.to_i
    when ""; day   = $2.to_i
    when ""; hour  = $2.to_i
      hour  += 12 if $1 == ""
    when "ʬ"; min   = $2.to_i
    when ""; sec   = $2.to_i
    end
  }
  Time.mktime(year, month, day, hour, min, sec)
end
