require 'htmlscanner.rb'

data = DATA.read        # __END__ ʹߤʬ DATA ɤळȤǤ

HTML::scan(data){|item|
  case item
  when HTML::Comment                      # 
    p [ item.type, item.value ]
  when HTML::MarkUpDecl                   # ޡå
    p [ item.type, item.value ]
  when HTML::StartTag                     # ϥ
    p [ item.type, item.name, item.attribute ]
  when HTML::EndTag                       # λ
    p [ item.type, item.name ]
  when HTML::TextData                     # ƥȥǡ
    tdata = item.value
    tdata.gsub!(/\s+/, " ")               # ޤȤ
    tdata.sub!(/ $/, "")                  # ζ
    p [ item.type, tdata ] unless tdata.empty?  # ǤʤнϤ
  end
}
__END__
<!DOCTYPE HTML>
<HTML>
  <BODY>
    <A name="FOO" href="foo" attr >foo</A>
    <A name='BAR' href='bar' attr >bar</A>
    <A name=BAZ href=baz attr >baz</A>
    <!--
      <A href="dummy">dummy</A>
    -->
  <BODY>
</HTML>
